import{S as Is,i as Ts,s as Ls,e as r,k as c,w as _s,t as a,M as xs,c as l,d as t,m as f,a as n,x as gs,h as s,b as i,G as e,g as h,y as ws,L as Ms,q as Es,o as ks,B as As,v as $s}from"../chunks/vendor-hf-doc-builder.js";import{I as Ps}from"../chunks/IconCopyLink-hf-doc-builder.js";function Os(ya){let A,Ve,P,x,Ee,S,kt,ke,At,Ze,Q,Pt,et,g,Ae,It,Tt,Pe,Lt,xt,Ie,Mt,tt,V,$t,ot,Z,Te,Ot,at,v,u,zt,ee,Ft,qt,te,St,Ht,oe,Nt,Ct,ae,Ut,jt,se,Dt,Kt,re,Rt,Wt,Gt,I,Yt,Le,Bt,Jt,H,Xt,Qt,Vt,b,Zt,le,eo,to,ne,oo,ao,xe,so,ro,lo,N,no,C,io,co,st,U,Me,fo,rt,M,$e,ho,uo,j,po,Oe,mo,vo,lt,ie,yo,nt,w,D,ze,bo,_o,K,Fe,go,wo,qe,Eo,ko,R,Se,Ao,Po,W,He,Io,To,Ne,Lo,xo,Ce,Ue,Mo,it,T,$,je,G,$o,De,Oo,dt,de,zo,ct,E,y,Ke,Fo,qo,Y,So,Ho,B,No,Co,J,Uo,jo,Do,ce,Re,Ko,Ro,Wo,p,We,Go,Yo,fe,Bo,Jo,he,Xo,Qo,ue,Vo,Zo,pe,ea,ta,ft,me,oa,ht,k,O,Ge,aa,sa,X,ra,la,na,z,Ye,ia,da,Be,ca,fa,ha,ve,Je,ua,pa,ut;return S=new Ps({}),G=new Ps({}),{c(){A=r("meta"),Ve=c(),P=r("h1"),x=r("a"),Ee=r("span"),_s(S.$$.fragment),kt=c(),ke=r("span"),At=a("Philosophy"),Ze=c(),Q=r("p"),Pt=a("\u{1F917} Transformers is an opinionated library built for:"),et=c(),g=r("ul"),Ae=r("li"),It=a("machine learning researchers and educators seeking to use, study or extend large-scale Transformers models."),Tt=c(),Pe=r("li"),Lt=a("hands-on practitioners who want to fine-tune those models or serve them in production, or both."),xt=c(),Ie=r("li"),Mt=a("engineers who just want to download a pretrained model and use it to solve a given machine learning task."),tt=c(),V=r("p"),$t=a("The library was designed with two strong goals in mind:"),ot=c(),Z=r("ol"),Te=r("li"),Ot=a("Be as easy and fast to use as possible:"),at=c(),v=r("ul"),u=r("li"),zt=a(`We strongly limited the number of user-facing abstractions to learn, in fact, there are almost no abstractions,
just three standard classes required to use each model: `),ee=r("a"),Ft=a("configuration"),qt=a(`,
`),te=r("a"),St=a("models"),Ht=a(", and a preprocessing class ("),oe=r("a"),Nt=a("tokenizer"),Ct=a(" for NLP, "),ae=r("a"),Ut=a("image processor"),jt=a(" for vision, "),se=r("a"),Dt=a("feature extractor"),Kt=a(" for audio, and "),re=r("a"),Rt=a("processor"),Wt=a(" for multimodal inputs)."),Gt=c(),I=r("li"),Yt=a(`All of these classes can be initialized in a simple and unified way from pretrained instances by using a common
`),Le=r("code"),Bt=a("from_pretrained()"),Jt=a(` method which downloads (if needed), caches and
loads the related class instance and associated data (configurations\u2019 hyperparameters, tokenizers\u2019 vocabulary,
and models\u2019 weights) from a pretrained checkpoint provided on `),H=r("a"),Xt=a("Hugging Face Hub"),Qt=a(" or your own saved checkpoint."),Vt=c(),b=r("li"),Zt=a("On top of those three base classes, the library provides two APIs: "),le=r("a"),eo=a("pipeline()"),to=a(` for quickly
using a model for inference on a given task and `),ne=r("a"),oo=a("Trainer"),ao=a(" to quickly train or fine-tune a PyTorch model (all TensorFlow models are compatible with "),xe=r("code"),so=a("Keras.fit"),ro=a(")."),lo=c(),N=r("li"),no=a(`As a consequence, this library is NOT a modular toolbox of building blocks for neural nets. If you want to
extend or build upon the library, just use regular Python, PyTorch, TensorFlow, Keras modules and inherit from the base
classes of the library to reuse functionalities like model loading and saving. If you\u2019d like to learn more about our coding philosophy for models, check out our `),C=r("a"),io=a("Repeat Yourself"),co=a(" blog post."),st=c(),U=r("ol"),Me=r("li"),fo=a("Provide state-of-the-art models with performances as close as possible to the original models:"),rt=c(),M=r("ul"),$e=r("li"),ho=a(`We provide at least one example for each architecture which reproduces a result provided by the official authors
of said architecture.`),uo=c(),j=r("li"),po=a(`The code is usually as close to the original code base as possible which means some PyTorch code may be not as
`),Oe=r("em"),mo=a("pytorchic"),vo=a(" as it could be as a result of being converted TensorFlow code and vice versa."),lt=c(),ie=r("p"),yo=a("A few other goals:"),nt=c(),w=r("ul"),D=r("li"),ze=r("p"),bo=a("Expose the models\u2019 internals as consistently as possible:"),_o=c(),K=r("ul"),Fe=r("li"),go=a("We give access, using a single API, to the full hidden-states and attention weights."),wo=c(),qe=r("li"),Eo=a("The preprocessing classes and base model APIs are standardized to easily switch between models."),ko=c(),R=r("li"),Se=r("p"),Ao=a("Incorporate a subjective selection of promising tools for fine-tuning and investigating these models:"),Po=c(),W=r("ul"),He=r("li"),Io=a("A simple and consistent way to add new tokens to the vocabulary and embeddings for fine-tuning."),To=c(),Ne=r("li"),Lo=a("Simple ways to mask and prune Transformer heads."),xo=c(),Ce=r("li"),Ue=r("p"),Mo=a("Easily switch between PyTorch, TensorFlow 2.0 and Flax, allowing training with one framework and inference with another."),it=c(),T=r("h2"),$=r("a"),je=r("span"),_s(G.$$.fragment),$o=c(),De=r("span"),Oo=a("Main concepts"),dt=c(),de=r("p"),zo=a("The library is built around three types of classes for each model:"),ct=c(),E=r("ul"),y=r("li"),Ke=r("strong"),Fo=a("Model classes"),qo=a(" can be PyTorch models ("),Y=r("a"),So=a("torch.nn.Module"),Ho=a("), Keras models ("),B=r("a"),No=a("tf.keras.Model"),Co=a(") or JAX/Flax models ("),J=r("a"),Uo=a("flax.linen.Module"),jo=a(") that work with the pretrained weights provided in the library."),Do=c(),ce=r("li"),Re=r("strong"),Ko=a("Configuration classes"),Ro=a(" store the hyperparameters required to build a model (such as the number of layers and hidden size). You don\u2019t always need to instantiate these yourself. In particular, if you are using a pretrained model without any modification, creating the model will automatically take care of instantiating the configuration (which is part of the model)."),Wo=c(),p=r("li"),We=r("strong"),Go=a("Preprocessing classes"),Yo=a(" convert the raw data into a format accepted by the model. A "),fe=r("a"),Bo=a("tokenizer"),Jo=a(" stores the vocabulary for each model and provide methods for encoding and decoding strings in a list of token embedding indices to be fed to a model. "),he=r("a"),Xo=a("Image processors"),Qo=a(" preprocess vision inputs, "),ue=r("a"),Vo=a("feature extractors"),Zo=a(" preprocess audio inputs, and a "),pe=r("a"),ea=a("processor"),ta=a(" handles multimodal inputs."),ft=c(),me=r("p"),oa=a("All these classes can be instantiated from pretrained instances, saved locally, and shared on the Hub with three methods:"),ht=c(),k=r("ul"),O=r("li"),Ge=r("code"),aa=a("from_pretrained()"),sa=a(` lets you instantiate a model, configuration, and preprocessing class from a pretrained version either
provided by the library itself (the supported models can be found on the `),X=r("a"),ra=a("Model Hub"),la=a(`) or
stored locally (or on a server) by the user.`),na=c(),z=r("li"),Ye=r("code"),ia=a("save_pretrained()"),da=a(` lets you save a model, configuration, and preprocessing class locally so that it can be reloaded using
`),Be=r("code"),ca=a("from_pretrained()"),fa=a("."),ha=c(),ve=r("li"),Je=r("code"),ua=a("push_to_hub()"),pa=a(" lets you share a model, configuration, and a preprocessing class to the Hub, so it is easily accessible to everyone."),this.h()},l(o){const d=xs('[data-svelte="svelte-1phssyn"]',document.head);A=l(d,"META",{name:!0,content:!0}),d.forEach(t),Ve=f(o),P=l(o,"H1",{class:!0});var pt=n(P);x=l(pt,"A",{id:!0,class:!0,href:!0});var ba=n(x);Ee=l(ba,"SPAN",{});var _a=n(Ee);gs(S.$$.fragment,_a),_a.forEach(t),ba.forEach(t),kt=f(pt),ke=l(pt,"SPAN",{});var ga=n(ke);At=s(ga,"Philosophy"),ga.forEach(t),pt.forEach(t),Ze=f(o),Q=l(o,"P",{});var wa=n(Q);Pt=s(wa,"\u{1F917} Transformers is an opinionated library built for:"),wa.forEach(t),et=f(o),g=l(o,"UL",{});var ye=n(g);Ae=l(ye,"LI",{});var Ea=n(Ae);It=s(Ea,"machine learning researchers and educators seeking to use, study or extend large-scale Transformers models."),Ea.forEach(t),Tt=f(ye),Pe=l(ye,"LI",{});var ka=n(Pe);Lt=s(ka,"hands-on practitioners who want to fine-tune those models or serve them in production, or both."),ka.forEach(t),xt=f(ye),Ie=l(ye,"LI",{});var Aa=n(Ie);Mt=s(Aa,"engineers who just want to download a pretrained model and use it to solve a given machine learning task."),Aa.forEach(t),ye.forEach(t),tt=f(o),V=l(o,"P",{});var Pa=n(V);$t=s(Pa,"The library was designed with two strong goals in mind:"),Pa.forEach(t),ot=f(o),Z=l(o,"OL",{});var Ia=n(Z);Te=l(Ia,"LI",{});var Ta=n(Te);Ot=s(Ta,"Be as easy and fast to use as possible:"),Ta.forEach(t),Ia.forEach(t),at=f(o),v=l(o,"UL",{});var F=n(v);u=l(F,"LI",{});var m=n(u);zt=s(m,`We strongly limited the number of user-facing abstractions to learn, in fact, there are almost no abstractions,
just three standard classes required to use each model: `),ee=l(m,"A",{href:!0});var La=n(ee);Ft=s(La,"configuration"),La.forEach(t),qt=s(m,`,
`),te=l(m,"A",{href:!0});var xa=n(te);St=s(xa,"models"),xa.forEach(t),Ht=s(m,", and a preprocessing class ("),oe=l(m,"A",{href:!0});var Ma=n(oe);Nt=s(Ma,"tokenizer"),Ma.forEach(t),Ct=s(m," for NLP, "),ae=l(m,"A",{href:!0});var $a=n(ae);Ut=s($a,"image processor"),$a.forEach(t),jt=s(m," for vision, "),se=l(m,"A",{href:!0});var Oa=n(se);Dt=s(Oa,"feature extractor"),Oa.forEach(t),Kt=s(m," for audio, and "),re=l(m,"A",{href:!0});var za=n(re);Rt=s(za,"processor"),za.forEach(t),Wt=s(m," for multimodal inputs)."),m.forEach(t),Gt=f(F),I=l(F,"LI",{});var be=n(I);Yt=s(be,`All of these classes can be initialized in a simple and unified way from pretrained instances by using a common
`),Le=l(be,"CODE",{});var Fa=n(Le);Bt=s(Fa,"from_pretrained()"),Fa.forEach(t),Jt=s(be,` method which downloads (if needed), caches and
loads the related class instance and associated data (configurations\u2019 hyperparameters, tokenizers\u2019 vocabulary,
and models\u2019 weights) from a pretrained checkpoint provided on `),H=l(be,"A",{href:!0,rel:!0});var qa=n(H);Xt=s(qa,"Hugging Face Hub"),qa.forEach(t),Qt=s(be," or your own saved checkpoint."),be.forEach(t),Vt=f(F),b=l(F,"LI",{});var q=n(b);Zt=s(q,"On top of those three base classes, the library provides two APIs: "),le=l(q,"A",{href:!0});var Sa=n(le);eo=s(Sa,"pipeline()"),Sa.forEach(t),to=s(q,` for quickly
using a model for inference on a given task and `),ne=l(q,"A",{href:!0});var Ha=n(ne);oo=s(Ha,"Trainer"),Ha.forEach(t),ao=s(q," to quickly train or fine-tune a PyTorch model (all TensorFlow models are compatible with "),xe=l(q,"CODE",{});var Na=n(xe);so=s(Na,"Keras.fit"),Na.forEach(t),ro=s(q,")."),q.forEach(t),lo=f(F),N=l(F,"LI",{});var mt=n(N);no=s(mt,`As a consequence, this library is NOT a modular toolbox of building blocks for neural nets. If you want to
extend or build upon the library, just use regular Python, PyTorch, TensorFlow, Keras modules and inherit from the base
classes of the library to reuse functionalities like model loading and saving. If you\u2019d like to learn more about our coding philosophy for models, check out our `),C=l(mt,"A",{href:!0,rel:!0});var Ca=n(C);io=s(Ca,"Repeat Yourself"),Ca.forEach(t),co=s(mt," blog post."),mt.forEach(t),F.forEach(t),st=f(o),U=l(o,"OL",{start:!0});var Ua=n(U);Me=l(Ua,"LI",{});var ja=n(Me);fo=s(ja,"Provide state-of-the-art models with performances as close as possible to the original models:"),ja.forEach(t),Ua.forEach(t),rt=f(o),M=l(o,"UL",{});var vt=n(M);$e=l(vt,"LI",{});var Da=n($e);ho=s(Da,`We provide at least one example for each architecture which reproduces a result provided by the official authors
of said architecture.`),Da.forEach(t),uo=f(vt),j=l(vt,"LI",{});var yt=n(j);po=s(yt,`The code is usually as close to the original code base as possible which means some PyTorch code may be not as
`),Oe=l(yt,"EM",{});var Ka=n(Oe);mo=s(Ka,"pytorchic"),Ka.forEach(t),vo=s(yt," as it could be as a result of being converted TensorFlow code and vice versa."),yt.forEach(t),vt.forEach(t),lt=f(o),ie=l(o,"P",{});var Ra=n(ie);yo=s(Ra,"A few other goals:"),Ra.forEach(t),nt=f(o),w=l(o,"UL",{});var _e=n(w);D=l(_e,"LI",{});var bt=n(D);ze=l(bt,"P",{});var Wa=n(ze);bo=s(Wa,"Expose the models\u2019 internals as consistently as possible:"),Wa.forEach(t),_o=f(bt),K=l(bt,"UL",{});var _t=n(K);Fe=l(_t,"LI",{});var Ga=n(Fe);go=s(Ga,"We give access, using a single API, to the full hidden-states and attention weights."),Ga.forEach(t),wo=f(_t),qe=l(_t,"LI",{});var Ya=n(qe);Eo=s(Ya,"The preprocessing classes and base model APIs are standardized to easily switch between models."),Ya.forEach(t),_t.forEach(t),bt.forEach(t),ko=f(_e),R=l(_e,"LI",{});var gt=n(R);Se=l(gt,"P",{});var Ba=n(Se);Ao=s(Ba,"Incorporate a subjective selection of promising tools for fine-tuning and investigating these models:"),Ba.forEach(t),Po=f(gt),W=l(gt,"UL",{});var wt=n(W);He=l(wt,"LI",{});var Ja=n(He);Io=s(Ja,"A simple and consistent way to add new tokens to the vocabulary and embeddings for fine-tuning."),Ja.forEach(t),To=f(wt),Ne=l(wt,"LI",{});var Xa=n(Ne);Lo=s(Xa,"Simple ways to mask and prune Transformer heads."),Xa.forEach(t),wt.forEach(t),gt.forEach(t),xo=f(_e),Ce=l(_e,"LI",{});var Qa=n(Ce);Ue=l(Qa,"P",{});var Va=n(Ue);Mo=s(Va,"Easily switch between PyTorch, TensorFlow 2.0 and Flax, allowing training with one framework and inference with another."),Va.forEach(t),Qa.forEach(t),_e.forEach(t),it=f(o),T=l(o,"H2",{class:!0});var Et=n(T);$=l(Et,"A",{id:!0,class:!0,href:!0});var Za=n($);je=l(Za,"SPAN",{});var es=n(je);gs(G.$$.fragment,es),es.forEach(t),Za.forEach(t),$o=f(Et),De=l(Et,"SPAN",{});var ts=n(De);Oo=s(ts,"Main concepts"),ts.forEach(t),Et.forEach(t),dt=f(o),de=l(o,"P",{});var os=n(de);zo=s(os,"The library is built around three types of classes for each model:"),os.forEach(t),ct=f(o),E=l(o,"UL",{});var ge=n(E);y=l(ge,"LI",{});var L=n(y);Ke=l(L,"STRONG",{});var as=n(Ke);Fo=s(as,"Model classes"),as.forEach(t),qo=s(L," can be PyTorch models ("),Y=l(L,"A",{href:!0,rel:!0});var ss=n(Y);So=s(ss,"torch.nn.Module"),ss.forEach(t),Ho=s(L,"), Keras models ("),B=l(L,"A",{href:!0,rel:!0});var rs=n(B);No=s(rs,"tf.keras.Model"),rs.forEach(t),Co=s(L,") or JAX/Flax models ("),J=l(L,"A",{href:!0,rel:!0});var ls=n(J);Uo=s(ls,"flax.linen.Module"),ls.forEach(t),jo=s(L,") that work with the pretrained weights provided in the library."),L.forEach(t),Do=f(ge),ce=l(ge,"LI",{});var ma=n(ce);Re=l(ma,"STRONG",{});var ns=n(Re);Ko=s(ns,"Configuration classes"),ns.forEach(t),Ro=s(ma," store the hyperparameters required to build a model (such as the number of layers and hidden size). You don\u2019t always need to instantiate these yourself. In particular, if you are using a pretrained model without any modification, creating the model will automatically take care of instantiating the configuration (which is part of the model)."),ma.forEach(t),Wo=f(ge),p=l(ge,"LI",{});var _=n(p);We=l(_,"STRONG",{});var is=n(We);Go=s(is,"Preprocessing classes"),is.forEach(t),Yo=s(_," convert the raw data into a format accepted by the model. A "),fe=l(_,"A",{href:!0});var ds=n(fe);Bo=s(ds,"tokenizer"),ds.forEach(t),Jo=s(_," stores the vocabulary for each model and provide methods for encoding and decoding strings in a list of token embedding indices to be fed to a model. "),he=l(_,"A",{href:!0});var cs=n(he);Xo=s(cs,"Image processors"),cs.forEach(t),Qo=s(_," preprocess vision inputs, "),ue=l(_,"A",{href:!0});var fs=n(ue);Vo=s(fs,"feature extractors"),fs.forEach(t),Zo=s(_," preprocess audio inputs, and a "),pe=l(_,"A",{href:!0});var hs=n(pe);ea=s(hs,"processor"),hs.forEach(t),ta=s(_," handles multimodal inputs."),_.forEach(t),ge.forEach(t),ft=f(o),me=l(o,"P",{});var us=n(me);oa=s(us,"All these classes can be instantiated from pretrained instances, saved locally, and shared on the Hub with three methods:"),us.forEach(t),ht=f(o),k=l(o,"UL",{});var we=n(k);O=l(we,"LI",{});var Xe=n(O);Ge=l(Xe,"CODE",{});var ps=n(Ge);aa=s(ps,"from_pretrained()"),ps.forEach(t),sa=s(Xe,` lets you instantiate a model, configuration, and preprocessing class from a pretrained version either
provided by the library itself (the supported models can be found on the `),X=l(Xe,"A",{href:!0,rel:!0});var ms=n(X);ra=s(ms,"Model Hub"),ms.forEach(t),la=s(Xe,`) or
stored locally (or on a server) by the user.`),Xe.forEach(t),na=f(we),z=l(we,"LI",{});var Qe=n(z);Ye=l(Qe,"CODE",{});var vs=n(Ye);ia=s(vs,"save_pretrained()"),vs.forEach(t),da=s(Qe,` lets you save a model, configuration, and preprocessing class locally so that it can be reloaded using
`),Be=l(Qe,"CODE",{});var ys=n(Be);ca=s(ys,"from_pretrained()"),ys.forEach(t),fa=s(Qe,"."),Qe.forEach(t),ha=f(we),ve=l(we,"LI",{});var va=n(ve);Je=l(va,"CODE",{});var bs=n(Je);ua=s(bs,"push_to_hub()"),bs.forEach(t),pa=s(va," lets you share a model, configuration, and a preprocessing class to the Hub, so it is easily accessible to everyone."),va.forEach(t),we.forEach(t),this.h()},h(){i(A,"name","hf:doc:metadata"),i(A,"content",JSON.stringify(zs)),i(x,"id","philosophy"),i(x,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),i(x,"href","#philosophy"),i(P,"class","relative group"),i(ee,"href","main_classes/configuration"),i(te,"href","main_classes/model"),i(oe,"href","main_classes/tokenizer"),i(ae,"href","main_classes/image_processor"),i(se,"href","main_classes/feature_extractor"),i(re,"href","main_classes/processors"),i(H,"href","https://huggingface.co/models"),i(H,"rel","nofollow"),i(le,"href","/docs/transformers/pr_101/en/main_classes/pipelines#transformers.pipeline"),i(ne,"href","/docs/transformers/pr_101/en/main_classes/trainer#transformers.Trainer"),i(C,"href","https://huggingface.co/blog/transformers-design-philosophy"),i(C,"rel","nofollow"),i(U,"start","2"),i($,"id","main-concepts"),i($,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),i($,"href","#main-concepts"),i(T,"class","relative group"),i(Y,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),i(Y,"rel","nofollow"),i(B,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),i(B,"rel","nofollow"),i(J,"href","https://flax.readthedocs.io/en/latest/api_reference/flax.linen.html"),i(J,"rel","nofollow"),i(fe,"href","main_classes/tokenizer"),i(he,"href","main_classes/image_processor"),i(ue,"href","main_classes/feature_extractor"),i(pe,"href","main_classes/processors"),i(X,"href","https://huggingface.co/models"),i(X,"rel","nofollow")},m(o,d){e(document.head,A),h(o,Ve,d),h(o,P,d),e(P,x),e(x,Ee),ws(S,Ee,null),e(P,kt),e(P,ke),e(ke,At),h(o,Ze,d),h(o,Q,d),e(Q,Pt),h(o,et,d),h(o,g,d),e(g,Ae),e(Ae,It),e(g,Tt),e(g,Pe),e(Pe,Lt),e(g,xt),e(g,Ie),e(Ie,Mt),h(o,tt,d),h(o,V,d),e(V,$t),h(o,ot,d),h(o,Z,d),e(Z,Te),e(Te,Ot),h(o,at,d),h(o,v,d),e(v,u),e(u,zt),e(u,ee),e(ee,Ft),e(u,qt),e(u,te),e(te,St),e(u,Ht),e(u,oe),e(oe,Nt),e(u,Ct),e(u,ae),e(ae,Ut),e(u,jt),e(u,se),e(se,Dt),e(u,Kt),e(u,re),e(re,Rt),e(u,Wt),e(v,Gt),e(v,I),e(I,Yt),e(I,Le),e(Le,Bt),e(I,Jt),e(I,H),e(H,Xt),e(I,Qt),e(v,Vt),e(v,b),e(b,Zt),e(b,le),e(le,eo),e(b,to),e(b,ne),e(ne,oo),e(b,ao),e(b,xe),e(xe,so),e(b,ro),e(v,lo),e(v,N),e(N,no),e(N,C),e(C,io),e(N,co),h(o,st,d),h(o,U,d),e(U,Me),e(Me,fo),h(o,rt,d),h(o,M,d),e(M,$e),e($e,ho),e(M,uo),e(M,j),e(j,po),e(j,Oe),e(Oe,mo),e(j,vo),h(o,lt,d),h(o,ie,d),e(ie,yo),h(o,nt,d),h(o,w,d),e(w,D),e(D,ze),e(ze,bo),e(D,_o),e(D,K),e(K,Fe),e(Fe,go),e(K,wo),e(K,qe),e(qe,Eo),e(w,ko),e(w,R),e(R,Se),e(Se,Ao),e(R,Po),e(R,W),e(W,He),e(He,Io),e(W,To),e(W,Ne),e(Ne,Lo),e(w,xo),e(w,Ce),e(Ce,Ue),e(Ue,Mo),h(o,it,d),h(o,T,d),e(T,$),e($,je),ws(G,je,null),e(T,$o),e(T,De),e(De,Oo),h(o,dt,d),h(o,de,d),e(de,zo),h(o,ct,d),h(o,E,d),e(E,y),e(y,Ke),e(Ke,Fo),e(y,qo),e(y,Y),e(Y,So),e(y,Ho),e(y,B),e(B,No),e(y,Co),e(y,J),e(J,Uo),e(y,jo),e(E,Do),e(E,ce),e(ce,Re),e(Re,Ko),e(ce,Ro),e(E,Wo),e(E,p),e(p,We),e(We,Go),e(p,Yo),e(p,fe),e(fe,Bo),e(p,Jo),e(p,he),e(he,Xo),e(p,Qo),e(p,ue),e(ue,Vo),e(p,Zo),e(p,pe),e(pe,ea),e(p,ta),h(o,ft,d),h(o,me,d),e(me,oa),h(o,ht,d),h(o,k,d),e(k,O),e(O,Ge),e(Ge,aa),e(O,sa),e(O,X),e(X,ra),e(O,la),e(k,na),e(k,z),e(z,Ye),e(Ye,ia),e(z,da),e(z,Be),e(Be,ca),e(z,fa),e(k,ha),e(k,ve),e(ve,Je),e(Je,ua),e(ve,pa),ut=!0},p:Ms,i(o){ut||(Es(S.$$.fragment,o),Es(G.$$.fragment,o),ut=!0)},o(o){ks(S.$$.fragment,o),ks(G.$$.fragment,o),ut=!1},d(o){t(A),o&&t(Ve),o&&t(P),As(S),o&&t(Ze),o&&t(Q),o&&t(et),o&&t(g),o&&t(tt),o&&t(V),o&&t(ot),o&&t(Z),o&&t(at),o&&t(v),o&&t(st),o&&t(U),o&&t(rt),o&&t(M),o&&t(lt),o&&t(ie),o&&t(nt),o&&t(w),o&&t(it),o&&t(T),As(G),o&&t(dt),o&&t(de),o&&t(ct),o&&t(E),o&&t(ft),o&&t(me),o&&t(ht),o&&t(k)}}}const zs={local:"philosophy",sections:[{local:"main-concepts",title:"Main concepts"}],title:"Philosophy"};function Fs(ya){return $s(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Hs extends Is{constructor(A){super();Ts(this,A,Fs,Os,Ls,{})}}export{Hs as default,zs as metadata};
